import{S as jr,i as Gr,s as Jr,e as r,k as h,w as _t,t as o,M as Vr,c as i,d as a,m as f,a as n,x as wt,h as l,b as c,P as Kr,G as e,g as d,y as gt,L as Qr,q as yt,o as bt,B as Et,v as Xr}from"../../chunks/vendor-hf-doc-builder.js";import{I as Lt}from"../../chunks/IconCopyLink-hf-doc-builder.js";function Yr(Dl){let L,At,A,C,ye,K,pa,be,ua,kt,x,va,Q,_a,wa,Rt,D,ga,Ee,ya,ba,Pt,re,Ea,$t,v,Le,La,Aa,Ae,ka,Ra,ke,Pa,$a,Re,Ta,Ca,Pe,xa,Tt,I,Da,$e,Ia,Oa,Ct,k,O,Te,X,Ma,Ce,Sa,xt,M,Ua,ie,Na,qa,Dt,Y,xe,Il,It,b,Fa,De,za,Wa,Ie,Ba,Ha,Ot,R,S,Oe,Z,ja,Me,Ga,Mt,U,Ja,Se,Va,Ka,St,N,Qa,Ue,Xa,Ya,Ut,q,Za,ne,eo,to,Nt,F,ao,se,oo,lo,qt,z,ro,de,io,no,Ft,P,W,Ne,ee,so,qe,ho,zt,he,fo,Wt,g,Fe,co,mo,te,po,ze,uo,vo,_o,$,wo,We,go,yo,Be,bo,Eo,Lo,ae,Ao,He,ko,Ro,Bt,oe,je,Po,$o,Ht,m,B,Ge,To,Co,Je,xo,Do,Io,fe,Ve,Oo,Mo,So,ce,Ke,Uo,No,qo,_,Qe,Fo,zo,Xe,Wo,Bo,Ye,Ho,jo,Ze,Go,Jo,et,Vo,Ko,Qo,me,tt,Xo,Yo,Zo,H,at,el,tl,ot,al,ol,ll,p,lt,rl,il,rt,nl,sl,it,dl,hl,nt,fl,cl,st,ml,pl,dt,ul,vl,ht,_l,wl,jt,T,j,ft,le,gl,ct,yl,Gt,pe,bl,Jt,G,mt,ue,El,Ll,pt,ve,Al,Vt,J,kl,_e,Rl,Pl,Kt;return K=new Lt({}),X=new Lt({}),Z=new Lt({}),ee=new Lt({}),le=new Lt({}),{c(){L=r("meta"),At=h(),A=r("h1"),C=r("a"),ye=r("span"),_t(K.$$.fragment),pa=h(),be=r("span"),ua=o("LoRA"),kt=h(),x=r("p"),va=o("This conceptual guide gives a brief overview of "),Q=r("a"),_a=o("LoRA"),wa=o(`, a technique that accelerates
the fine-tuning of large models while consuming less memory.`),Rt=h(),D=r("p"),ga=o(`To make fine-tuning more efficient, LoRA\u2019s approach is to represent the weight updates with two smaller
matrices (called `),Ee=r("strong"),ya=o("update matrices"),ba=o(`) through low-rank decomposition. These new matrices can be trained to adapt to the
new data while keeping the overall number of changes low. The original weight matrix remains frozen and doesn\u2019t receive
any further adjustments. To produce the final results, both the original and the adapted weights are combined.`),Pt=h(),re=r("p"),Ea=o("This approach has a number of advantages:"),$t=h(),v=r("ul"),Le=r("li"),La=o("LoRA makes fine-tuning more efficient by drastically reducing the number of trainable parameters."),Aa=h(),Ae=r("li"),ka=o("The original pre-trained weights are kept frozen, which means you can have multiple lightweight and portable LoRA models for various downstream tasks built on top of them."),Ra=h(),ke=r("li"),Pa=o("LoRA is orthogonal to many other parameter-efficient methods and can be combined with many of them."),$a=h(),Re=r("li"),Ta=o("Performance of models fine-tuned using LoRA is comparable to the performance of fully fine-tuned models."),Ca=h(),Pe=r("li"),xa=o("LoRA does not add any inference latency because adapter weights can be merged with the base model."),Tt=h(),I=r("p"),Da=o(`In principle, LoRA can be applied to any subset of weight matrices in a neural network to reduce the number of trainable
parameters. However, for simplicity and further parameter efficiency, in Transformer models LoRA is typically applied to
attention blocks only. The resulting number of trainable parameters in a LoRA model depends on the size of the low-rank
update matrices, which is determined mainly by the rank `),$e=r("code"),Ia=o("r"),Oa=o(" and the shape of the original weight matrix."),Ct=h(),k=r("h2"),O=r("a"),Te=r("span"),_t(X.$$.fragment),Ma=h(),Ce=r("span"),Sa=o("Merge LoRA weights into the base model"),xt=h(),M=r("p"),Ua=o("While LoRA is significantly smaller and faster to train, you may encounter latency issues during inference due to separately loading the base model and the LoRA model. To eliminate latency, use the "),ie=r("a"),Na=o("merge_and_unload()"),qa=o(" function to merge the adapter weights with the base model which allows you to effectively use the newly merged model as a standalone model."),Dt=h(),Y=r("div"),xe=r("img"),It=h(),b=r("p"),Fa=o("This works because during training, the smaller weight matrices ("),De=r("em"),za=o("A"),Wa=o(" and "),Ie=r("em"),Ba=o("B"),Ha=o(" in the diagram above) are separate. But once training is complete, the weights can actually be merged into a new weight matrix that is identical."),Ot=h(),R=r("h2"),S=r("a"),Oe=r("span"),_t(Z.$$.fragment),ja=h(),Me=r("span"),Ga=o("Utils for LoRA"),Mt=h(),U=r("p"),Ja=o("Use "),Se=r("code"),Va=o("merge_adapter()"),Ka=o(` to merge the LoRa layers into the base model while retaining the PeftModel.
This will help in later unmerging, deleting, loading different adapters and so on.`),St=h(),N=r("p"),Qa=o("Use "),Ue=r("code"),Xa=o("unmerge_adapter()"),Ya=o(` to unmerge the LoRa layers from the base model while retaining the PeftModel.
This will help in later merging, deleting, loading different adapters and so on.`),Ut=h(),q=r("p"),Za=o("Use "),ne=r("a"),eo=o("unload()"),to=o(` to get back the base model without the merging of the active lora modules.
This will help when you want to get back the pretrained base model in some applications when you want to reset the model to its original state.
For example, in Stable Diffusion WebUi, when the user wants to infer with base model post trying out LoRAs.`),Nt=h(),F=r("p"),ao=o("Use "),se=r("a"),oo=o("delete_adapter()"),lo=o(" to delete an existing adapter."),qt=h(),z=r("p"),ro=o("Use "),de=r("a"),io=o("add_weighted_adapter()"),no=o(" to combine multiple LoRAs into a new adapter based on the user provided weighing scheme."),Ft=h(),P=r("h2"),W=r("a"),Ne=r("span"),_t(ee.$$.fragment),so=h(),qe=r("span"),ho=o("Common LoRA parameters in PEFT"),zt=h(),he=r("p"),fo=o("As with other methods supported by PEFT, to fine-tune a model using LoRA, you need to:"),Wt=h(),g=r("ol"),Fe=r("li"),co=o("Instantiate a base model."),mo=h(),te=r("li"),po=o("Create a configuration ("),ze=r("code"),uo=o("LoraConfig"),vo=o(") where you define LoRA-specific parameters."),_o=h(),$=r("li"),wo=o("Wrap the base model with "),We=r("code"),go=o("get_peft_model()"),yo=o(" to get a trainable "),Be=r("code"),bo=o("PeftModel"),Eo=o("."),Lo=h(),ae=r("li"),Ao=o("Train the "),He=r("code"),ko=o("PeftModel"),Ro=o(" as you normally would train the base model."),Bt=h(),oe=r("p"),je=r("code"),Po=o("LoraConfig"),$o=o(" allows you to control how LoRA is applied to the base model through the following parameters:"),Ht=h(),m=r("ul"),B=r("li"),Ge=r("code"),To=o("r"),Co=o(": the rank of the update matrices, expressed in "),Je=r("code"),xo=o("int"),Do=o(". Lower rank results in smaller update matrices with fewer trainable parameters."),Io=h(),fe=r("li"),Ve=r("code"),Oo=o("target_modules"),Mo=o(": The modules (for example, attention blocks) to apply the LoRA update matrices."),So=h(),ce=r("li"),Ke=r("code"),Uo=o("alpha"),No=o(": LoRA scaling factor."),qo=h(),_=r("li"),Qe=r("code"),Fo=o("bias"),zo=o(": Specifies if the "),Xe=r("code"),Wo=o("bias"),Bo=o(" parameters should be trained. Can be "),Ye=r("code"),Ho=o("'none'"),jo=o(", "),Ze=r("code"),Go=o("'all'"),Jo=o(" or "),et=r("code"),Vo=o("'lora_only'"),Ko=o("."),Qo=h(),me=r("li"),tt=r("code"),Xo=o("modules_to_save"),Yo=o(": List of modules apart from LoRA layers to be set as trainable and saved in the final checkpoint. These typically include model\u2019s custom head that is randomly initialized for the fine-tuning task."),Zo=h(),H=r("li"),at=r("code"),el=o("layers_to_transform"),tl=o(": List of layers to be transformed by LoRA. If not specified, all layers in "),ot=r("code"),al=o("target_modules"),ol=o(" are transformed."),ll=h(),p=r("li"),lt=r("code"),rl=o("layers_pattern"),il=o(": Pattern to match layer names in "),rt=r("code"),nl=o("target_modules"),sl=o(", if "),it=r("code"),dl=o("layers_to_transform"),hl=o(" is specified. By default "),nt=r("code"),fl=o("PeftModel"),cl=o(" will look at common layer pattern ("),st=r("code"),ml=o("layers"),pl=o(", "),dt=r("code"),ul=o("h"),vl=o(", "),ht=r("code"),_l=o("blocks"),wl=o(", etc.), use it for exotic and custom models."),jt=h(),T=r("h2"),j=r("a"),ft=r("span"),_t(le.$$.fragment),gl=h(),ct=r("span"),yl=o("LoRA examples"),Gt=h(),pe=r("p"),bl=o("For an example of LoRA method application to various downstream tasks, please refer to the following guides:"),Jt=h(),G=r("ul"),mt=r("li"),ue=r("a"),El=o("Image classification using LoRA"),Ll=h(),pt=r("li"),ve=r("a"),Al=o("Semantic segmentation"),Vt=h(),J=r("p"),kl=o(`While the original paper focuses on language models, the technique can be applied to any dense layers in deep learning
models. As such, you can leverage this technique with diffusion models. See `),_e=r("a"),Rl=o("Dreambooth fine-tuning with LoRA"),Pl=o(" task guide for an example."),this.h()},l(t){const s=Vr('[data-svelte="svelte-1phssyn"]',document.head);L=i(s,"META",{name:!0,content:!0}),s.forEach(a),At=f(t),A=i(t,"H1",{class:!0});var Qt=n(A);C=i(Qt,"A",{id:!0,class:!0,href:!0});var Ol=n(C);ye=i(Ol,"SPAN",{});var Ml=n(ye);wt(K.$$.fragment,Ml),Ml.forEach(a),Ol.forEach(a),pa=f(Qt),be=i(Qt,"SPAN",{});var Sl=n(be);ua=l(Sl,"LoRA"),Sl.forEach(a),Qt.forEach(a),kt=f(t),x=i(t,"P",{});var Xt=n(x);va=l(Xt,"This conceptual guide gives a brief overview of "),Q=i(Xt,"A",{href:!0,rel:!0});var Ul=n(Q);_a=l(Ul,"LoRA"),Ul.forEach(a),wa=l(Xt,`, a technique that accelerates
the fine-tuning of large models while consuming less memory.`),Xt.forEach(a),Rt=f(t),D=i(t,"P",{});var Yt=n(D);ga=l(Yt,`To make fine-tuning more efficient, LoRA\u2019s approach is to represent the weight updates with two smaller
matrices (called `),Ee=i(Yt,"STRONG",{});var Nl=n(Ee);ya=l(Nl,"update matrices"),Nl.forEach(a),ba=l(Yt,`) through low-rank decomposition. These new matrices can be trained to adapt to the
new data while keeping the overall number of changes low. The original weight matrix remains frozen and doesn\u2019t receive
any further adjustments. To produce the final results, both the original and the adapted weights are combined.`),Yt.forEach(a),Pt=f(t),re=i(t,"P",{});var ql=n(re);Ea=l(ql,"This approach has a number of advantages:"),ql.forEach(a),$t=f(t),v=i(t,"UL",{});var E=n(v);Le=i(E,"LI",{});var Fl=n(Le);La=l(Fl,"LoRA makes fine-tuning more efficient by drastically reducing the number of trainable parameters."),Fl.forEach(a),Aa=f(E),Ae=i(E,"LI",{});var zl=n(Ae);ka=l(zl,"The original pre-trained weights are kept frozen, which means you can have multiple lightweight and portable LoRA models for various downstream tasks built on top of them."),zl.forEach(a),Ra=f(E),ke=i(E,"LI",{});var Wl=n(ke);Pa=l(Wl,"LoRA is orthogonal to many other parameter-efficient methods and can be combined with many of them."),Wl.forEach(a),$a=f(E),Re=i(E,"LI",{});var Bl=n(Re);Ta=l(Bl,"Performance of models fine-tuned using LoRA is comparable to the performance of fully fine-tuned models."),Bl.forEach(a),Ca=f(E),Pe=i(E,"LI",{});var Hl=n(Pe);xa=l(Hl,"LoRA does not add any inference latency because adapter weights can be merged with the base model."),Hl.forEach(a),E.forEach(a),Tt=f(t),I=i(t,"P",{});var Zt=n(I);Da=l(Zt,`In principle, LoRA can be applied to any subset of weight matrices in a neural network to reduce the number of trainable
parameters. However, for simplicity and further parameter efficiency, in Transformer models LoRA is typically applied to
attention blocks only. The resulting number of trainable parameters in a LoRA model depends on the size of the low-rank
update matrices, which is determined mainly by the rank `),$e=i(Zt,"CODE",{});var jl=n($e);Ia=l(jl,"r"),jl.forEach(a),Oa=l(Zt," and the shape of the original weight matrix."),Zt.forEach(a),Ct=f(t),k=i(t,"H2",{class:!0});var ea=n(k);O=i(ea,"A",{id:!0,class:!0,href:!0});var Gl=n(O);Te=i(Gl,"SPAN",{});var Jl=n(Te);wt(X.$$.fragment,Jl),Jl.forEach(a),Gl.forEach(a),Ma=f(ea),Ce=i(ea,"SPAN",{});var Vl=n(Ce);Sa=l(Vl,"Merge LoRA weights into the base model"),Vl.forEach(a),ea.forEach(a),xt=f(t),M=i(t,"P",{});var ta=n(M);Ua=l(ta,"While LoRA is significantly smaller and faster to train, you may encounter latency issues during inference due to separately loading the base model and the LoRA model. To eliminate latency, use the "),ie=i(ta,"A",{href:!0});var Kl=n(ie);Na=l(Kl,"merge_and_unload()"),Kl.forEach(a),qa=l(ta," function to merge the adapter weights with the base model which allows you to effectively use the newly merged model as a standalone model."),ta.forEach(a),Dt=f(t),Y=i(t,"DIV",{class:!0});var Ql=n(Y);xe=i(Ql,"IMG",{src:!0}),Ql.forEach(a),It=f(t),b=i(t,"P",{});var we=n(b);Fa=l(we,"This works because during training, the smaller weight matrices ("),De=i(we,"EM",{});var Xl=n(De);za=l(Xl,"A"),Xl.forEach(a),Wa=l(we," and "),Ie=i(we,"EM",{});var Yl=n(Ie);Ba=l(Yl,"B"),Yl.forEach(a),Ha=l(we," in the diagram above) are separate. But once training is complete, the weights can actually be merged into a new weight matrix that is identical."),we.forEach(a),Ot=f(t),R=i(t,"H2",{class:!0});var aa=n(R);S=i(aa,"A",{id:!0,class:!0,href:!0});var Zl=n(S);Oe=i(Zl,"SPAN",{});var er=n(Oe);wt(Z.$$.fragment,er),er.forEach(a),Zl.forEach(a),ja=f(aa),Me=i(aa,"SPAN",{});var tr=n(Me);Ga=l(tr,"Utils for LoRA"),tr.forEach(a),aa.forEach(a),Mt=f(t),U=i(t,"P",{});var oa=n(U);Ja=l(oa,"Use "),Se=i(oa,"CODE",{});var ar=n(Se);Va=l(ar,"merge_adapter()"),ar.forEach(a),Ka=l(oa,` to merge the LoRa layers into the base model while retaining the PeftModel.
This will help in later unmerging, deleting, loading different adapters and so on.`),oa.forEach(a),St=f(t),N=i(t,"P",{});var la=n(N);Qa=l(la,"Use "),Ue=i(la,"CODE",{});var or=n(Ue);Xa=l(or,"unmerge_adapter()"),or.forEach(a),Ya=l(la,` to unmerge the LoRa layers from the base model while retaining the PeftModel.
This will help in later merging, deleting, loading different adapters and so on.`),la.forEach(a),Ut=f(t),q=i(t,"P",{});var ra=n(q);Za=l(ra,"Use "),ne=i(ra,"A",{href:!0});var lr=n(ne);eo=l(lr,"unload()"),lr.forEach(a),to=l(ra,` to get back the base model without the merging of the active lora modules.
This will help when you want to get back the pretrained base model in some applications when you want to reset the model to its original state.
For example, in Stable Diffusion WebUi, when the user wants to infer with base model post trying out LoRAs.`),ra.forEach(a),Nt=f(t),F=i(t,"P",{});var ia=n(F);ao=l(ia,"Use "),se=i(ia,"A",{href:!0});var rr=n(se);oo=l(rr,"delete_adapter()"),rr.forEach(a),lo=l(ia," to delete an existing adapter."),ia.forEach(a),qt=f(t),z=i(t,"P",{});var na=n(z);ro=l(na,"Use "),de=i(na,"A",{href:!0});var ir=n(de);io=l(ir,"add_weighted_adapter()"),ir.forEach(a),no=l(na," to combine multiple LoRAs into a new adapter based on the user provided weighing scheme."),na.forEach(a),Ft=f(t),P=i(t,"H2",{class:!0});var sa=n(P);W=i(sa,"A",{id:!0,class:!0,href:!0});var nr=n(W);Ne=i(nr,"SPAN",{});var sr=n(Ne);wt(ee.$$.fragment,sr),sr.forEach(a),nr.forEach(a),so=f(sa),qe=i(sa,"SPAN",{});var dr=n(qe);ho=l(dr,"Common LoRA parameters in PEFT"),dr.forEach(a),sa.forEach(a),zt=f(t),he=i(t,"P",{});var hr=n(he);fo=l(hr,"As with other methods supported by PEFT, to fine-tune a model using LoRA, you need to:"),hr.forEach(a),Wt=f(t),g=i(t,"OL",{});var V=n(g);Fe=i(V,"LI",{});var fr=n(Fe);co=l(fr,"Instantiate a base model."),fr.forEach(a),mo=f(V),te=i(V,"LI",{});var da=n(te);po=l(da,"Create a configuration ("),ze=i(da,"CODE",{});var cr=n(ze);uo=l(cr,"LoraConfig"),cr.forEach(a),vo=l(da,") where you define LoRA-specific parameters."),da.forEach(a),_o=f(V),$=i(V,"LI",{});var ge=n($);wo=l(ge,"Wrap the base model with "),We=i(ge,"CODE",{});var mr=n(We);go=l(mr,"get_peft_model()"),mr.forEach(a),yo=l(ge," to get a trainable "),Be=i(ge,"CODE",{});var pr=n(Be);bo=l(pr,"PeftModel"),pr.forEach(a),Eo=l(ge,"."),ge.forEach(a),Lo=f(V),ae=i(V,"LI",{});var ha=n(ae);Ao=l(ha,"Train the "),He=i(ha,"CODE",{});var ur=n(He);ko=l(ur,"PeftModel"),ur.forEach(a),Ro=l(ha," as you normally would train the base model."),ha.forEach(a),V.forEach(a),Bt=f(t),oe=i(t,"P",{});var $l=n(oe);je=i($l,"CODE",{});var vr=n(je);Po=l(vr,"LoraConfig"),vr.forEach(a),$o=l($l," allows you to control how LoRA is applied to the base model through the following parameters:"),$l.forEach(a),Ht=f(t),m=i(t,"UL",{});var w=n(m);B=i(w,"LI",{});var ut=n(B);Ge=i(ut,"CODE",{});var _r=n(Ge);To=l(_r,"r"),_r.forEach(a),Co=l(ut,": the rank of the update matrices, expressed in "),Je=i(ut,"CODE",{});var wr=n(Je);xo=l(wr,"int"),wr.forEach(a),Do=l(ut,". Lower rank results in smaller update matrices with fewer trainable parameters."),ut.forEach(a),Io=f(w),fe=i(w,"LI",{});var Tl=n(fe);Ve=i(Tl,"CODE",{});var gr=n(Ve);Oo=l(gr,"target_modules"),gr.forEach(a),Mo=l(Tl,": The modules (for example, attention blocks) to apply the LoRA update matrices."),Tl.forEach(a),So=f(w),ce=i(w,"LI",{});var Cl=n(ce);Ke=i(Cl,"CODE",{});var yr=n(Ke);Uo=l(yr,"alpha"),yr.forEach(a),No=l(Cl,": LoRA scaling factor."),Cl.forEach(a),qo=f(w),_=i(w,"LI",{});var y=n(_);Qe=i(y,"CODE",{});var br=n(Qe);Fo=l(br,"bias"),br.forEach(a),zo=l(y,": Specifies if the "),Xe=i(y,"CODE",{});var Er=n(Xe);Wo=l(Er,"bias"),Er.forEach(a),Bo=l(y," parameters should be trained. Can be "),Ye=i(y,"CODE",{});var Lr=n(Ye);Ho=l(Lr,"'none'"),Lr.forEach(a),jo=l(y,", "),Ze=i(y,"CODE",{});var Ar=n(Ze);Go=l(Ar,"'all'"),Ar.forEach(a),Jo=l(y," or "),et=i(y,"CODE",{});var kr=n(et);Vo=l(kr,"'lora_only'"),kr.forEach(a),Ko=l(y,"."),y.forEach(a),Qo=f(w),me=i(w,"LI",{});var xl=n(me);tt=i(xl,"CODE",{});var Rr=n(tt);Xo=l(Rr,"modules_to_save"),Rr.forEach(a),Yo=l(xl,": List of modules apart from LoRA layers to be set as trainable and saved in the final checkpoint. These typically include model\u2019s custom head that is randomly initialized for the fine-tuning task."),xl.forEach(a),Zo=f(w),H=i(w,"LI",{});var vt=n(H);at=i(vt,"CODE",{});var Pr=n(at);el=l(Pr,"layers_to_transform"),Pr.forEach(a),tl=l(vt,": List of layers to be transformed by LoRA. If not specified, all layers in "),ot=i(vt,"CODE",{});var $r=n(ot);al=l($r,"target_modules"),$r.forEach(a),ol=l(vt," are transformed."),vt.forEach(a),ll=f(w),p=i(w,"LI",{});var u=n(p);lt=i(u,"CODE",{});var Tr=n(lt);rl=l(Tr,"layers_pattern"),Tr.forEach(a),il=l(u,": Pattern to match layer names in "),rt=i(u,"CODE",{});var Cr=n(rt);nl=l(Cr,"target_modules"),Cr.forEach(a),sl=l(u,", if "),it=i(u,"CODE",{});var xr=n(it);dl=l(xr,"layers_to_transform"),xr.forEach(a),hl=l(u," is specified. By default "),nt=i(u,"CODE",{});var Dr=n(nt);fl=l(Dr,"PeftModel"),Dr.forEach(a),cl=l(u," will look at common layer pattern ("),st=i(u,"CODE",{});var Ir=n(st);ml=l(Ir,"layers"),Ir.forEach(a),pl=l(u,", "),dt=i(u,"CODE",{});var Or=n(dt);ul=l(Or,"h"),Or.forEach(a),vl=l(u,", "),ht=i(u,"CODE",{});var Mr=n(ht);_l=l(Mr,"blocks"),Mr.forEach(a),wl=l(u,", etc.), use it for exotic and custom models."),u.forEach(a),w.forEach(a),jt=f(t),T=i(t,"H2",{class:!0});var fa=n(T);j=i(fa,"A",{id:!0,class:!0,href:!0});var Sr=n(j);ft=i(Sr,"SPAN",{});var Ur=n(ft);wt(le.$$.fragment,Ur),Ur.forEach(a),Sr.forEach(a),gl=f(fa),ct=i(fa,"SPAN",{});var Nr=n(ct);yl=l(Nr,"LoRA examples"),Nr.forEach(a),fa.forEach(a),Gt=f(t),pe=i(t,"P",{});var qr=n(pe);bl=l(qr,"For an example of LoRA method application to various downstream tasks, please refer to the following guides:"),qr.forEach(a),Jt=f(t),G=i(t,"UL",{});var ca=n(G);mt=i(ca,"LI",{});var Fr=n(mt);ue=i(Fr,"A",{href:!0});var zr=n(ue);El=l(zr,"Image classification using LoRA"),zr.forEach(a),Fr.forEach(a),Ll=f(ca),pt=i(ca,"LI",{});var Wr=n(pt);ve=i(Wr,"A",{href:!0});var Br=n(ve);Al=l(Br,"Semantic segmentation"),Br.forEach(a),Wr.forEach(a),ca.forEach(a),Vt=f(t),J=i(t,"P",{});var ma=n(J);kl=l(ma,`While the original paper focuses on language models, the technique can be applied to any dense layers in deep learning
models. As such, you can leverage this technique with diffusion models. See `),_e=i(ma,"A",{href:!0});var Hr=n(_e);Rl=l(Hr,"Dreambooth fine-tuning with LoRA"),Hr.forEach(a),Pl=l(ma," task guide for an example."),ma.forEach(a),this.h()},h(){c(L,"name","hf:doc:metadata"),c(L,"content",JSON.stringify(Zr)),c(C,"id","lora"),c(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(C,"href","#lora"),c(A,"class","relative group"),c(Q,"href","https://arxiv.org/abs/2106.09685"),c(Q,"rel","nofollow"),c(O,"id","merge-lora-weights-into-the-base-model"),c(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(O,"href","#merge-lora-weights-into-the-base-model"),c(k,"class","relative group"),c(ie,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.merge_and_unload"),Kr(xe.src,Il="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/lora_diagram.png")||c(xe,"src",Il),c(Y,"class","flex justify-center"),c(S,"id","utils-for-lora"),c(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(S,"href","#utils-for-lora"),c(R,"class","relative group"),c(ne,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.unload"),c(se,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.delete_adapter"),c(de,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.add_weighted_adapter"),c(W,"id","common-lora-parameters-in-peft"),c(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(W,"href","#common-lora-parameters-in-peft"),c(P,"class","relative group"),c(j,"id","lora-examples"),c(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(j,"href","#lora-examples"),c(T,"class","relative group"),c(ue,"href","../task_guides/image_classification_lora"),c(ve,"href","../task_guides/semantic_segmentation_lora"),c(_e,"href","../task_guides/task_guides/dreambooth_lora")},m(t,s){e(document.head,L),d(t,At,s),d(t,A,s),e(A,C),e(C,ye),gt(K,ye,null),e(A,pa),e(A,be),e(be,ua),d(t,kt,s),d(t,x,s),e(x,va),e(x,Q),e(Q,_a),e(x,wa),d(t,Rt,s),d(t,D,s),e(D,ga),e(D,Ee),e(Ee,ya),e(D,ba),d(t,Pt,s),d(t,re,s),e(re,Ea),d(t,$t,s),d(t,v,s),e(v,Le),e(Le,La),e(v,Aa),e(v,Ae),e(Ae,ka),e(v,Ra),e(v,ke),e(ke,Pa),e(v,$a),e(v,Re),e(Re,Ta),e(v,Ca),e(v,Pe),e(Pe,xa),d(t,Tt,s),d(t,I,s),e(I,Da),e(I,$e),e($e,Ia),e(I,Oa),d(t,Ct,s),d(t,k,s),e(k,O),e(O,Te),gt(X,Te,null),e(k,Ma),e(k,Ce),e(Ce,Sa),d(t,xt,s),d(t,M,s),e(M,Ua),e(M,ie),e(ie,Na),e(M,qa),d(t,Dt,s),d(t,Y,s),e(Y,xe),d(t,It,s),d(t,b,s),e(b,Fa),e(b,De),e(De,za),e(b,Wa),e(b,Ie),e(Ie,Ba),e(b,Ha),d(t,Ot,s),d(t,R,s),e(R,S),e(S,Oe),gt(Z,Oe,null),e(R,ja),e(R,Me),e(Me,Ga),d(t,Mt,s),d(t,U,s),e(U,Ja),e(U,Se),e(Se,Va),e(U,Ka),d(t,St,s),d(t,N,s),e(N,Qa),e(N,Ue),e(Ue,Xa),e(N,Ya),d(t,Ut,s),d(t,q,s),e(q,Za),e(q,ne),e(ne,eo),e(q,to),d(t,Nt,s),d(t,F,s),e(F,ao),e(F,se),e(se,oo),e(F,lo),d(t,qt,s),d(t,z,s),e(z,ro),e(z,de),e(de,io),e(z,no),d(t,Ft,s),d(t,P,s),e(P,W),e(W,Ne),gt(ee,Ne,null),e(P,so),e(P,qe),e(qe,ho),d(t,zt,s),d(t,he,s),e(he,fo),d(t,Wt,s),d(t,g,s),e(g,Fe),e(Fe,co),e(g,mo),e(g,te),e(te,po),e(te,ze),e(ze,uo),e(te,vo),e(g,_o),e(g,$),e($,wo),e($,We),e(We,go),e($,yo),e($,Be),e(Be,bo),e($,Eo),e(g,Lo),e(g,ae),e(ae,Ao),e(ae,He),e(He,ko),e(ae,Ro),d(t,Bt,s),d(t,oe,s),e(oe,je),e(je,Po),e(oe,$o),d(t,Ht,s),d(t,m,s),e(m,B),e(B,Ge),e(Ge,To),e(B,Co),e(B,Je),e(Je,xo),e(B,Do),e(m,Io),e(m,fe),e(fe,Ve),e(Ve,Oo),e(fe,Mo),e(m,So),e(m,ce),e(ce,Ke),e(Ke,Uo),e(ce,No),e(m,qo),e(m,_),e(_,Qe),e(Qe,Fo),e(_,zo),e(_,Xe),e(Xe,Wo),e(_,Bo),e(_,Ye),e(Ye,Ho),e(_,jo),e(_,Ze),e(Ze,Go),e(_,Jo),e(_,et),e(et,Vo),e(_,Ko),e(m,Qo),e(m,me),e(me,tt),e(tt,Xo),e(me,Yo),e(m,Zo),e(m,H),e(H,at),e(at,el),e(H,tl),e(H,ot),e(ot,al),e(H,ol),e(m,ll),e(m,p),e(p,lt),e(lt,rl),e(p,il),e(p,rt),e(rt,nl),e(p,sl),e(p,it),e(it,dl),e(p,hl),e(p,nt),e(nt,fl),e(p,cl),e(p,st),e(st,ml),e(p,pl),e(p,dt),e(dt,ul),e(p,vl),e(p,ht),e(ht,_l),e(p,wl),d(t,jt,s),d(t,T,s),e(T,j),e(j,ft),gt(le,ft,null),e(T,gl),e(T,ct),e(ct,yl),d(t,Gt,s),d(t,pe,s),e(pe,bl),d(t,Jt,s),d(t,G,s),e(G,mt),e(mt,ue),e(ue,El),e(G,Ll),e(G,pt),e(pt,ve),e(ve,Al),d(t,Vt,s),d(t,J,s),e(J,kl),e(J,_e),e(_e,Rl),e(J,Pl),Kt=!0},p:Qr,i(t){Kt||(yt(K.$$.fragment,t),yt(X.$$.fragment,t),yt(Z.$$.fragment,t),yt(ee.$$.fragment,t),yt(le.$$.fragment,t),Kt=!0)},o(t){bt(K.$$.fragment,t),bt(X.$$.fragment,t),bt(Z.$$.fragment,t),bt(ee.$$.fragment,t),bt(le.$$.fragment,t),Kt=!1},d(t){a(L),t&&a(At),t&&a(A),Et(K),t&&a(kt),t&&a(x),t&&a(Rt),t&&a(D),t&&a(Pt),t&&a(re),t&&a($t),t&&a(v),t&&a(Tt),t&&a(I),t&&a(Ct),t&&a(k),Et(X),t&&a(xt),t&&a(M),t&&a(Dt),t&&a(Y),t&&a(It),t&&a(b),t&&a(Ot),t&&a(R),Et(Z),t&&a(Mt),t&&a(U),t&&a(St),t&&a(N),t&&a(Ut),t&&a(q),t&&a(Nt),t&&a(F),t&&a(qt),t&&a(z),t&&a(Ft),t&&a(P),Et(ee),t&&a(zt),t&&a(he),t&&a(Wt),t&&a(g),t&&a(Bt),t&&a(oe),t&&a(Ht),t&&a(m),t&&a(jt),t&&a(T),Et(le),t&&a(Gt),t&&a(pe),t&&a(Jt),t&&a(G),t&&a(Vt),t&&a(J)}}}const Zr={local:"lora",sections:[{local:"merge-lora-weights-into-the-base-model",title:"Merge LoRA weights into the base model"},{local:"utils-for-lora",title:"Utils for LoRA"},{local:"common-lora-parameters-in-peft",title:"Common LoRA parameters in PEFT"},{local:"lora-examples",title:"LoRA examples"}],title:"LoRA "};function ei(Dl){return Xr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class oi extends jr{constructor(L){super();Gr(this,L,ei,Yr,Jr,{})}}export{oi as default,Zr as metadata};
